import * as i0 from '@angular/core';
import { Component, Input, ViewChild, EventEmitter, HostBinding, Output, Directive, ChangeDetectionStrategy, NgModule } from '@angular/core';
import { MatCheckbox, MatCheckboxModule } from '@angular/material/checkbox';
import * as i4 from '@angular/material/sort';
import { MatSort, MatSortModule } from '@angular/material/sort';
import * as i3$1 from '@angular/material/table';
import { MatTableDataSource, MatTableModule } from '@angular/material/table';
import { Subject } from 'rxjs';
import { takeUntil } from 'rxjs/operators';
import * as i1 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i2 from '@angular/material/list';
import { MatListModule } from '@angular/material/list';
import * as i3 from '@angular/material/divider';
import { TdHighlightComponent, CovalentHighlightModule } from '@covalent/highlight';
import * as i1$1 from '@covalent/markdown';
import { scrollToAnchor, TdMarkdownComponent, CovalentMarkdownModule } from '@covalent/markdown';
import * as i5 from '@angular/material/button';
import { MatButtonModule } from '@angular/material/button';
import * as i3$2 from '@angular/material/progress-bar';
import { MatProgressBarModule } from '@angular/material/progress-bar';
import { __awaiter } from 'tslib';

function TdFlavoredListComponent_ng_template_1_p_3_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelementStart(0, "p", 4);
        i0.ɵɵtext(1);
        i0.ɵɵelementEnd();
    }
    if (rf & 2) {
        const subline_r5 = ctx.$implicit;
        i0.ɵɵadvance(1);
        i0.ɵɵtextInterpolate1(" ", subline_r5, " ");
    }
}
function TdFlavoredListComponent_ng_template_1_mat_divider_4_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelement(0, "mat-divider", 4);
    }
}
function TdFlavoredListComponent_ng_template_1_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelementStart(0, "mat-list-item")(1, "h4", 1);
        i0.ɵɵtext(2);
        i0.ɵɵelementEnd();
        i0.ɵɵtemplate(3, TdFlavoredListComponent_ng_template_1_p_3_Template, 2, 1, "p", 2);
        i0.ɵɵtemplate(4, TdFlavoredListComponent_ng_template_1_mat_divider_4_Template, 1, 0, "mat-divider", 3);
        i0.ɵɵelementEnd();
    }
    if (rf & 2) {
        const line_r1 = ctx.$implicit;
        const last_r2 = ctx.last;
        i0.ɵɵadvance(2);
        i0.ɵɵtextInterpolate1(" ", line_r1.line, " ");
        i0.ɵɵadvance(1);
        i0.ɵɵproperty("ngForOf", line_r1.sublines);
        i0.ɵɵadvance(1);
        i0.ɵɵproperty("ngIf", !last_r2);
    }
}
class TdFlavoredListComponent {
    constructor() {
        this.dense = false;
    }
}
TdFlavoredListComponent.ɵfac = function TdFlavoredListComponent_Factory(t) { return new (t || TdFlavoredListComponent)(); };
TdFlavoredListComponent.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: TdFlavoredListComponent, selectors: [["td-cfm-list"]], inputs: { lines: "lines", dense: "dense" }, decls: 2, vars: 2, consts: [["ngFor", "", 3, "ngForOf"], ["matListItemTitle", ""], ["matListItemLine", "", 4, "ngFor", "ngForOf"], ["matListItemLine", "", 4, "ngIf"], ["matListItemLine", ""]], template: function TdFlavoredListComponent_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-list");
            i0.ɵɵtemplate(1, TdFlavoredListComponent_ng_template_1_Template, 5, 3, "ng-template", 0);
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            i0.ɵɵattribute("dense", ctx.dense ? true : null);
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("ngForOf", ctx.lines);
        }
    }, dependencies: [i1.NgForOf, i1.NgIf, i2.MatList, i2.MatListItem, i3.MatDivider, i2.MatListItemLine, i2.MatListItemTitle] });
(function () {
    (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(TdFlavoredListComponent, [{
            type: Component,
            args: [{ selector: 'td-cfm-list', template: "<mat-list [attr.dense]=\"dense ? true : null\">\n  <ng-template let-line let-last=\"last\" ngFor [ngForOf]=\"lines\">\n    <mat-list-item>\n      <h4 matListItemTitle>\n        {{ line.line }}\n      </h4>\n      <p *ngFor=\"let subline of line.sublines\" matListItemLine>\n        {{ subline }}\n      </p>\n      <mat-divider *ngIf=\"!last\" matListItemLine></mat-divider>\n    </mat-list-item>\n  </ng-template>\n</mat-list>\n" }]
        }], null, { lines: [{
                type: Input
            }], dense: [{
                type: Input
            }] });
})();

function TdFlavoredMarkdownTableComponent_ng_template_1_mat_header_cell_1_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelementStart(0, "mat-header-cell", 7);
        i0.ɵɵtext(1);
        i0.ɵɵelementEnd();
    }
    if (rf & 2) {
        const column_r3 = i0.ɵɵnextContext().$implicit;
        i0.ɵɵadvance(1);
        i0.ɵɵtextInterpolate(column_r3.label);
    }
}
function TdFlavoredMarkdownTableComponent_ng_template_1_mat_cell_2_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelementStart(0, "mat-cell")(1, "td-markdown");
        i0.ɵɵtext(2);
        i0.ɵɵelementEnd()();
    }
    if (rf & 2) {
        const row_r7 = ctx.$implicit;
        const column_r3 = i0.ɵɵnextContext().$implicit;
        i0.ɵɵadvance(2);
        i0.ɵɵtextInterpolate(row_r7[column_r3.name]);
    }
}
function TdFlavoredMarkdownTableComponent_ng_template_1_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelementContainerStart(0, 4);
        i0.ɵɵtemplate(1, TdFlavoredMarkdownTableComponent_ng_template_1_mat_header_cell_1_Template, 2, 1, "mat-header-cell", 5);
        i0.ɵɵtemplate(2, TdFlavoredMarkdownTableComponent_ng_template_1_mat_cell_2_Template, 3, 1, "mat-cell", 6);
        i0.ɵɵelementContainerEnd();
    }
    if (rf & 2) {
        const column_r3 = ctx.$implicit;
        i0.ɵɵproperty("matColumnDef", column_r3.name);
    }
}
function TdFlavoredMarkdownTableComponent_mat_header_row_2_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelement(0, "mat-header-row");
    }
}
function TdFlavoredMarkdownTableComponent_mat_row_3_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelement(0, "mat-row");
    }
}
const _c0 = ["*"];
class TdFlavoredMarkdownTableComponent {
    constructor() {
        this.columnDefs = [];
    }
    ngOnInit() {
        this.displayedColumns = this.columnDefs.map((c) => c.name);
        this.dataSource = new MatTableDataSource(this.data);
    }
    ngAfterViewInit() {
        this.dataSource.sort = this.sort;
    }
}
TdFlavoredMarkdownTableComponent.ɵfac = function TdFlavoredMarkdownTableComponent_Factory(t) { return new (t || TdFlavoredMarkdownTableComponent)(); };
TdFlavoredMarkdownTableComponent.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: TdFlavoredMarkdownTableComponent, selectors: [["ng-component"]], viewQuery: function TdFlavoredMarkdownTableComponent_Query(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵviewQuery(MatSort, 5);
        }
        if (rf & 2) {
            let _t;
            i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.sort = _t.first);
        }
    }, inputs: { columnDefs: "columnDefs", data: "data" }, decls: 4, vars: 4, consts: [["matSort", "", 3, "dataSource"], ["ngFor", "", 3, "ngForOf"], [4, "matHeaderRowDef"], [4, "matRowDef", "matRowDefColumns"], [3, "matColumnDef"], ["mat-sort-header", "", 4, "matHeaderCellDef"], [4, "matCellDef"], ["mat-sort-header", ""]], template: function TdFlavoredMarkdownTableComponent_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "mat-table", 0);
            i0.ɵɵtemplate(1, TdFlavoredMarkdownTableComponent_ng_template_1_Template, 3, 1, "ng-template", 1);
            i0.ɵɵtemplate(2, TdFlavoredMarkdownTableComponent_mat_header_row_2_Template, 1, 0, "mat-header-row", 2);
            i0.ɵɵtemplate(3, TdFlavoredMarkdownTableComponent_mat_row_3_Template, 1, 0, "mat-row", 3);
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            i0.ɵɵproperty("dataSource", ctx.dataSource);
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("ngForOf", ctx.columnDefs);
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("matHeaderRowDef", ctx.displayedColumns);
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("matRowDefColumns", ctx.displayedColumns);
        }
    }, dependencies: [i1.NgForOf, i1$1.TdMarkdownComponent, i3$1.MatTable, i3$1.MatHeaderCellDef, i3$1.MatHeaderRowDef, i3$1.MatColumnDef, i3$1.MatCellDef, i3$1.MatRowDef, i3$1.MatHeaderCell, i3$1.MatCell, i3$1.MatHeaderRow, i3$1.MatRow, i4.MatSort, i4.MatSortHeader], encapsulation: 2 });
(function () {
    (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(TdFlavoredMarkdownTableComponent, [{
            type: Component,
            args: [{
                    template: `
    <mat-table [dataSource]="dataSource" matSort>
      <!-- Column Definition -->
      <ng-template ngFor let-column [ngForOf]="columnDefs">
        <ng-container [matColumnDef]="column.name">
          <mat-header-cell *matHeaderCellDef mat-sort-header>{{
            column.label
          }}</mat-header-cell>
          <mat-cell *matCellDef="let row"
            ><td-markdown>{{ row[column.name] }}</td-markdown></mat-cell
          >
        </ng-container>
      </ng-template>
      <!-- Header and Row Declarations -->
      <mat-header-row *matHeaderRowDef="displayedColumns"></mat-header-row>
      <mat-row *matRowDef="let row; columns: displayedColumns"></mat-row>
    </mat-table>
  `,
                }]
        }], null, { columnDefs: [{
                type: Input
            }], data: [{
                type: Input
            }], sort: [{
                type: ViewChild,
                args: [MatSort]
            }] });
})();
class TdFlavoredMarkdownButtonComponent {
    constructor() {
        this.display = 'inline-block';
        this.text = '';
        this.data = '';
        this.clicked = new EventEmitter();
    }
    emitClick() {
        this.clicked.emit({ text: this.text, data: this.data });
    }
}
TdFlavoredMarkdownButtonComponent.ɵfac = function TdFlavoredMarkdownButtonComponent_Factory(t) { return new (t || TdFlavoredMarkdownButtonComponent)(); };
TdFlavoredMarkdownButtonComponent.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: TdFlavoredMarkdownButtonComponent, selectors: [["ng-component"]], hostVars: 2, hostBindings: function TdFlavoredMarkdownButtonComponent_HostBindings(rf, ctx) {
        if (rf & 2) {
            i0.ɵɵstyleProp("display", ctx.display);
        }
    }, inputs: { text: "text", data: "data" }, outputs: { clicked: "clicked" }, decls: 2, vars: 1, consts: [["mat-raised-button", "", 3, "click"]], template: function TdFlavoredMarkdownButtonComponent_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵelementStart(0, "button", 0);
            i0.ɵɵlistener("click", function TdFlavoredMarkdownButtonComponent_Template_button_click_0_listener() { return ctx.emitClick(); });
            i0.ɵɵtext(1);
            i0.ɵɵelementEnd();
        }
        if (rf & 2) {
            i0.ɵɵadvance(1);
            i0.ɵɵtextInterpolate1(" ", ctx.text, " ");
        }
    }, dependencies: [i5.MatButton], encapsulation: 2 });
(function () {
    (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(TdFlavoredMarkdownButtonComponent, [{
            type: Component,
            args: [{
                    template: `
    <button mat-raised-button (click)="emitClick()">
      {{ text }}
    </button>
  `,
                }]
        }], null, { display: [{
                type: HostBinding,
                args: ['style.display']
            }], text: [{
                type: Input
            }], data: [{
                type: Input
            }], clicked: [{
                type: Output
            }] });
})();
class TdFlavoredMarkdownContainerDirective {
    constructor(viewContainerRef, _renderer) {
        this.viewContainerRef = viewContainerRef;
        this._renderer = _renderer;
    }
    clear() {
        this._renderer.setProperty(this.viewContainerRef.element.nativeElement, 'innerHTML', '');
        this.viewContainerRef.clear();
    }
}
TdFlavoredMarkdownContainerDirective.ɵfac = function TdFlavoredMarkdownContainerDirective_Factory(t) { return new (t || TdFlavoredMarkdownContainerDirective)(i0.ɵɵdirectiveInject(i0.ViewContainerRef), i0.ɵɵdirectiveInject(i0.Renderer2)); };
TdFlavoredMarkdownContainerDirective.ɵdir = /*@__PURE__*/ i0.ɵɵdefineDirective({ type: TdFlavoredMarkdownContainerDirective, selectors: [["", "tdFlavoredMarkdownContainer", ""]] });
(function () {
    (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(TdFlavoredMarkdownContainerDirective, [{
            type: Directive,
            args: [{
                    selector: '[tdFlavoredMarkdownContainer]',
                }]
        }], function () { return [{ type: i0.ViewContainerRef }, { type: i0.Renderer2 }]; }, null);
})();
class TdFlavoredMarkdownComponent {
    /**
     * content?: string
     *
     * Markdown format content to be parsed as material/covalent markup.
     *
     * e.g. README.md content.
     */
    set content(content) {
        this._content = content;
    }
    /**
     * simpleLineBreaks?: string
     *
     * Sets whether newline characters inside paragraphs and spans are parsed as <br/>.
     * Defaults to false.
     */
    set simpleLineBreaks(simpleLineBreaks) {
        this._simpleLineBreaks = simpleLineBreaks;
    }
    /**
     * hostedUrl?: string
     *
     * If markdown contains relative paths, this is required to generate correct urls
     *
     */
    set hostedUrl(hostedUrl) {
        this._hostedUrl = hostedUrl;
    }
    /**
     * anchor?: string
     *
     * Anchor to jump to
     *
     */
    set anchor(anchor) {
        this._anchor = anchor;
    }
    constructor(_componentFactoryResolver, _renderer, _changeDetectorRef, _injector, _elementRef) {
        this._componentFactoryResolver = _componentFactoryResolver;
        this._renderer = _renderer;
        this._changeDetectorRef = _changeDetectorRef;
        this._injector = _injector;
        this._elementRef = _elementRef;
        this._simpleLineBreaks = false;
        this._components = {};
        this._viewInit = false;
        /**
         * copyCodeToClipboard?: boolean
         *
         * Display copy button on code snippets to copy code to clipboard.
         *
         */
        this.copyCodeToClipboard = false;
        /**
         * copyCodeTooltips?: ICopyCodeTooltips
         *
         * Tooltips for copy button to copy and upon copying.
         */
        this.copyCodeTooltips = {};
        /**
         * toggleRawCode?: boolean
         *
         * Display button to toggle raw code view
         */
        this.toggleRawCode = false;
        /**
         * rawToggleLabels?: IRawToggleLabels
         *
         * Labels for raw code toggle button
         */
        this.rawToggleLabels = {};
        /**
         * useCfmList?: boolean = false;
         * Use CFM list component instead of vanilla markdown list. Used in covalent documentation app.
         */
        this.useCfmList = false;
        /**
         * contentReady?: function
         * Event emitted after the markdown content rendering is finished.
         */
        this.contentReady = new EventEmitter();
        /**
         * buttonClicked?: ITdFlavoredMarkdownButtonClickEvent
         * Event emitted when a button is clicked
         * Is an object containing text and data of button
         */
        this.buttonClicked = new EventEmitter();
        this._destroy$ = new Subject();
    }
    ngOnChanges(changes) {
        // only anchor changed
        if (changes['anchor'] &&
            !changes['content'] &&
            !changes['simpleLineBreaks'] &&
            !changes['hostedUrl']) {
            scrollToAnchor(this._elementRef.nativeElement, this._anchor, false);
        }
        else {
            this.refresh();
        }
    }
    ngAfterViewInit() {
        var _a;
        if (!this._content) {
            this._loadContent((_a = this.container.viewContainerRef.element.nativeElement
                .textContent) !== null && _a !== void 0 ? _a : '');
            Promise.resolve().then(() => {
                this._viewInit = true;
                this._changeDetectorRef.markForCheck();
            });
        }
    }
    ngOnDestroy() {
        this._destroy$.next();
    }
    refresh() {
        var _a;
        if (this._content) {
            this._loadContent(this._content);
        }
        else if (this._viewInit) {
            this._loadContent((_a = this.container.viewContainerRef.element.nativeElement
                .textContent) !== null && _a !== void 0 ? _a : '');
        }
        this._changeDetectorRef.markForCheck();
    }
    _loadContent(markdown) {
        if (markdown && markdown.trim().length > 0) {
            this.container.clear();
            markdown = markdown
                .replace(/^(\s|\t)*\n+/g, '')
                .replace(/(\s|\t)*\n+(\s|\t)*$/g, '');
            // Split markdown by line characters
            let lines = markdown.split('\n');
            // check how much indentation is used by the first actual markdown line
            const firstLineWhitespaceMatch = lines[0].match(/^(\s|\t)*/);
            const firstLineWhitespace = firstLineWhitespaceMatch
                ? firstLineWhitespaceMatch[0]
                : null;
            // Remove all indentation spaces so markdown can be parsed correctly
            // Remove all \r characters
            const startingWhitespaceRegex = new RegExp('^' + firstLineWhitespace);
            lines = lines.map(function (line) {
                return line.replace(startingWhitespaceRegex, '').replace('\r', '');
            });
            // Join lines again with line characters
            markdown = [...lines, '', ''].join('\n');
            markdown = this._replaceCodeBlocks(markdown);
            markdown = this._replaceCheckbox(markdown);
            markdown = this._replaceTables(markdown);
            markdown = this._replaceButtons(markdown);
            if (this.useCfmList) {
                markdown = this._replaceLists(markdown);
            }
            const keys = Object.keys(this._components);
            // need to sort the placeholders in order of encounter in markdown content
            keys.sort((compA, compB) => {
                return markdown.indexOf(compA) > markdown.indexOf(compB) ? 1 : -1;
            });
            this._render(markdown, keys[0], keys);
            // TODO: timeout required since resizing of html elements occurs which causes a change in the scroll position
            setTimeout(() => scrollToAnchor(this._elementRef.nativeElement, this._anchor, false), 250);
            this.contentReady.emit();
            Promise.resolve().then(() => {
                this._changeDetectorRef.markForCheck();
            });
        }
    }
    _render(markdown, key, keys) {
        if (!markdown) {
            return;
        }
        if (key && markdown.indexOf(key) > -1) {
            const markdownParts = markdown.split(key);
            keys.shift();
            this._render(markdownParts[0], '', []);
            this.container.viewContainerRef.insert(this._components[key].hostView, this.container.viewContainerRef.length);
            delete this._components[key];
            this._render(markdownParts[1], keys[0], keys);
        }
        else {
            const contentRef = this._componentFactoryResolver
                .resolveComponentFactory(TdMarkdownComponent)
                .create(this._injector);
            contentRef.instance.content = markdown;
            contentRef.instance.hostedUrl = this._hostedUrl;
            contentRef.instance.simpleLineBreaks = this._simpleLineBreaks;
            contentRef.instance.refresh();
            this.container.viewContainerRef.insert(contentRef.hostView, this.container.viewContainerRef.length);
        }
    }
    _replaceComponent(markdown, type, regExp, replacerFunc) {
        let componentIndex = 0;
        return markdown.replace(regExp, (...args) => {
            const componentFactory = this._componentFactoryResolver.resolveComponentFactory(type);
            const componentRef = componentFactory.create(this._injector);
            replacerFunc(componentRef, ...args);
            const key = '[' +
                componentFactory.selector +
                '-placeholder-' +
                componentIndex++ +
                ']';
            this._components[key] = componentRef;
            return key;
        });
    }
    _replaceCheckbox(markdown) {
        const checkboxRegExp = /(?:^|\n)- \[(x| )\](.*)/gi;
        return this._replaceComponent(markdown, MatCheckbox, checkboxRegExp, (componentRef, match, checked, label) => {
            componentRef.instance.checked = !!checked.trim();
            componentRef.instance.ariaLabel = label;
            componentRef.instance.labelPosition = 'after';
            this._renderer.setProperty((componentRef.instance._elementRef.nativeElement).getElementsByTagName('label')[0], 'innerHTML', label);
        });
    }
    _replaceButtons(markdown) {
        const buttonRegExp = /\[([^[]+)\](\(#data=(.*?)\))/i;
        const globalButtonRegExp = new RegExp(buttonRegExp.source, buttonRegExp.flags + 'g');
        return this._replaceComponent(markdown, TdFlavoredMarkdownButtonComponent, globalButtonRegExp, (componentRef, match) => {
            const matches = buttonRegExp.exec(match);
            if (!matches) {
                return;
            }
            const text = matches[1];
            const data = matches[3];
            componentRef.instance.text = text;
            componentRef.instance.data = data;
            componentRef.instance.clicked
                .pipe(takeUntil(this._destroy$))
                .subscribe((clickEvent) => this.buttonClicked.emit(clickEvent));
        });
    }
    _replaceCodeBlocks(markdown) {
        const codeBlockRegExp = /(?:^|\n)```(.*)\n([\s\S]*?)\n```/g;
        return this._replaceComponent(markdown, TdHighlightComponent, codeBlockRegExp, (componentRef, match, language, codeblock) => {
            if (language) {
                componentRef.instance.codeLang = language;
            }
            componentRef.instance.copyCodeToClipboard = this.copyCodeToClipboard;
            componentRef.instance.copyCodeTooltips = this.copyCodeTooltips;
            componentRef.instance.toggleRawButton = this.toggleRawCode;
            componentRef.instance.rawToggleLabels = this.rawToggleLabels;
            componentRef.instance.content = codeblock;
        });
    }
    _replaceTables(markdown) {
        const tableRgx = /^ {0,3}\|?.+\|.+\n[ \t]{0,3}\|?[ \t]*:?[ \t]*(?:-|=){2,}[ \t]*:?[ \t]*\|[ \t]*:?[ \t]*(?:-|=){2,}[\s\S]+?(?:\n\n|~0)/gm;
        return this._replaceComponent(markdown, TdFlavoredMarkdownTableComponent, tableRgx, (componentRef, match) => {
            const dataTableLines = match
                .replace(/(\s|\t)*\n+(\s|\t)*$/g, '')
                .split('\n');
            const columns = dataTableLines[0]
                .split('|')
                .filter((col) => {
                return col;
            })
                .map((s) => {
                return s.trim();
            });
            const alignment = dataTableLines[1]
                .split('|')
                .filter((v) => {
                return v;
            })
                .map((s) => {
                return s.trim();
            });
            const data = [];
            for (let i = 2; i < dataTableLines.length; i++) {
                const rowSplit = dataTableLines[i]
                    .split('|')
                    .filter((cell) => {
                    return cell;
                })
                    .map((s) => {
                    return s.trim();
                });
                const row = {};
                columns.forEach((col, index) => {
                    const rowSplitCell = rowSplit[index];
                    if (rowSplitCell) {
                        row[col.toLowerCase().trim()] = rowSplitCell.replace(/`(.*)`/, (m, value) => {
                            return value;
                        });
                    }
                });
                data.push(row);
            }
            componentRef.instance.columnDefs = columns.map((col, index) => {
                return {
                    label: col,
                    name: col ? col.toLowerCase().trim() : `column ${index}`,
                    numeric: /^--*[ \t]*:[ \t]*$/.test(alignment[index]),
                };
            });
            componentRef.instance.data = data;
        });
    }
    _replaceLists(markdown) {
        const listRegExp = /(?:^|\n)(( *(\+|\*|-))[ |\t](.*)\n)+/g;
        const listCharRegExp = new RegExp(/^(\+|\*|-)/);
        return this._replaceComponent(markdown, TdFlavoredListComponent, listRegExp, (componentRef, match) => {
            const start = /(\+|\*|-)/.exec(match);
            const matchIndex = start !== null ? start.index : 1;
            const lineTexts = match.split(new RegExp('\\n {' + (matchIndex - 1).toString() + '}(\\+|\\*|\\-)[ |\\t]'));
            lineTexts.shift();
            const lines = [];
            lineTexts.forEach((text) => {
                var _a;
                const sublineTexts = text.split(/\n *(\+|\*|-) /);
                const lineText = (_a = sublineTexts.shift()) !== null && _a !== void 0 ? _a : '';
                if (listCharRegExp.test(lineText)) {
                    return;
                }
                lines.push({
                    line: lineText,
                    sublines: sublineTexts
                        .map((subline) => {
                        if (listCharRegExp.test(subline)) {
                            return '';
                        }
                        return subline.trim();
                    })
                        .filter((line) => !!line),
                });
            });
            componentRef.instance.lines = lines;
        });
    }
}
TdFlavoredMarkdownComponent.ɵfac = function TdFlavoredMarkdownComponent_Factory(t) { return new (t || TdFlavoredMarkdownComponent)(i0.ɵɵdirectiveInject(i0.ComponentFactoryResolver), i0.ɵɵdirectiveInject(i0.Renderer2), i0.ɵɵdirectiveInject(i0.ChangeDetectorRef), i0.ɵɵdirectiveInject(i0.Injector), i0.ɵɵdirectiveInject(i0.ElementRef)); };
TdFlavoredMarkdownComponent.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: TdFlavoredMarkdownComponent, selectors: [["td-flavored-markdown"]], viewQuery: function TdFlavoredMarkdownComponent_Query(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵviewQuery(TdFlavoredMarkdownContainerDirective, 7);
        }
        if (rf & 2) {
            let _t;
            i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.container = _t.first);
        }
    }, inputs: { content: "content", simpleLineBreaks: "simpleLineBreaks", hostedUrl: "hostedUrl", anchor: "anchor", copyCodeToClipboard: "copyCodeToClipboard", copyCodeTooltips: "copyCodeTooltips", toggleRawCode: "toggleRawCode", rawToggleLabels: "rawToggleLabels", useCfmList: "useCfmList" }, outputs: { contentReady: "contentReady", buttonClicked: "buttonClicked" }, features: [i0.ɵɵNgOnChangesFeature], ngContentSelectors: _c0, decls: 2, vars: 0, consts: [["tdFlavoredMarkdownContainer", ""]], template: function TdFlavoredMarkdownComponent_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵprojectionDef();
            i0.ɵɵelementStart(0, "div", 0);
            i0.ɵɵprojection(1);
            i0.ɵɵelementEnd();
        }
    }, dependencies: [TdFlavoredMarkdownContainerDirective], styles: ["[_nghost-%COMP%]     td-markdown:first-of-type>div:first-of-type>h1:first-of-type, [_nghost-%COMP%]     td-markdown:first-of-type>div:first-of-type>h2:first-of-type{margin-top:0}[_nghost-%COMP%]     mat-checkbox{display:block}[_nghost-%COMP%]     td-highlight, [_nghost-%COMP%]     mat-table, [_nghost-%COMP%]     mat-checkbox:last-of-type{margin-bottom:16px}[_nghost-%COMP%]     :not(pre)>code{font-family:Menlo,Monaco,Andale Mono,lucida console,Courier New,monospace;padding-left:2px;padding-right:2px}[_nghost-%COMP%]     td-highlight{display:flex;flex-direction:row;justify-content:space-between}"], changeDetection: 0 });
(function () {
    (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(TdFlavoredMarkdownComponent, [{
            type: Component,
            args: [{ selector: 'td-flavored-markdown', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div tdFlavoredMarkdownContainer>\n  <ng-content></ng-content>\n</div>\n", styles: [":host ::ng-deep td-markdown:first-of-type>div:first-of-type>h1:first-of-type,:host ::ng-deep td-markdown:first-of-type>div:first-of-type>h2:first-of-type{margin-top:0}:host ::ng-deep mat-checkbox{display:block}:host ::ng-deep td-highlight,:host ::ng-deep mat-table,:host ::ng-deep mat-checkbox:last-of-type{margin-bottom:16px}:host ::ng-deep :not(pre)>code{font-family:Menlo,Monaco,Andale Mono,lucida console,Courier New,monospace;padding-left:2px;padding-right:2px}:host ::ng-deep td-highlight{display:flex;flex-direction:row;justify-content:space-between}\n"] }]
        }], function () { return [{ type: i0.ComponentFactoryResolver }, { type: i0.Renderer2 }, { type: i0.ChangeDetectorRef }, { type: i0.Injector }, { type: i0.ElementRef }]; }, { content: [{
                type: Input
            }], simpleLineBreaks: [{
                type: Input
            }], hostedUrl: [{
                type: Input
            }], anchor: [{
                type: Input
            }], copyCodeToClipboard: [{
                type: Input
            }], copyCodeTooltips: [{
                type: Input
            }], toggleRawCode: [{
                type: Input
            }], rawToggleLabels: [{
                type: Input
            }], useCfmList: [{
                type: Input
            }], contentReady: [{
                type: Output
            }], buttonClicked: [{
                type: Output
            }], container: [{
                type: ViewChild,
                args: [TdFlavoredMarkdownContainerDirective, { static: true }]
            }] });
})();

function TdFlavoredMarkdownLoaderComponent_mat_progress_bar_0_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelement(0, "mat-progress-bar", 2);
    }
    if (rf & 2) {
        i0.ɵɵproperty("ngClass", "delay");
    }
}
function TdFlavoredMarkdownLoaderComponent_td_flavored_markdown_1_Template(rf, ctx) {
    if (rf & 1) {
        const _r3 = i0.ɵɵgetCurrentView();
        i0.ɵɵelementStart(0, "td-flavored-markdown", 3);
        i0.ɵɵlistener("contentReady", function TdFlavoredMarkdownLoaderComponent_td_flavored_markdown_1_Template_td_flavored_markdown_contentReady_0_listener() { i0.ɵɵrestoreView(_r3); const ctx_r2 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r2.contentReady.emit()); })("buttonClicked", function TdFlavoredMarkdownLoaderComponent_td_flavored_markdown_1_Template_td_flavored_markdown_buttonClicked_0_listener($event) { i0.ɵɵrestoreView(_r3); const ctx_r4 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r4.buttonClicked.emit($event)); });
        i0.ɵɵelementEnd();
    }
    if (rf & 2) {
        const ctx_r1 = i0.ɵɵnextContext();
        let tmp_1_0;
        let tmp_2_0;
        i0.ɵɵproperty("content", ctx_r1.content)("hostedUrl", (tmp_1_0 = ctx_r1.url) !== null && tmp_1_0 !== undefined ? tmp_1_0 : "")("anchor", (tmp_2_0 = ctx_r1.anchor) !== null && tmp_2_0 !== undefined ? tmp_2_0 : "")("copyCodeToClipboard", ctx_r1.copyCodeToClipboard)("copyCodeTooltips", ctx_r1.copyCodeTooltips)("useCfmList", ctx_r1.useCfmList);
    }
}
// TODO: make a td-markdown-loader component
class TdFlavoredMarkdownLoaderComponent {
    constructor(_changeDetectorRef, _markdownUrlLoaderService) {
        this._changeDetectorRef = _changeDetectorRef;
        this._markdownUrlLoaderService = _markdownUrlLoaderService;
        /**
         * copyCodeToClipboard?: boolean
         *
         * Display copy button on code snippets to copy code to clipboard.
         *
         */
        this.copyCodeToClipboard = false;
        /**
         * copyCodeTooltips?: ICopyCodeTooltips
         *
         * Tooltips for copy button to copy and upon copying.
         */
        this.copyCodeTooltips = {};
        /**
         * useCfmList?: boolean = false;
         * Use CFM list component instead of vanilla markdown list. Used in covalent documentation app.
         */
        this.useCfmList = false;
        /**
         * contentReady: void
         * Emitted when markdown rendering is finished.
         */
        this.contentReady = new EventEmitter();
        /**
         * loadFailed: Error
         * Emitted when loading of markdown file fails.
         */
        this.loadFailed = new EventEmitter();
        this.buttonClicked = new EventEmitter();
        this.loading = true;
    }
    ngOnChanges(changes) {
        if (changes['url'] || changes['httpOptions']) {
            this.loadMarkdown();
        }
    }
    loadMarkdown() {
        var _a;
        return __awaiter(this, void 0, void 0, function* () {
            this.loading = true;
            this._changeDetectorRef.markForCheck();
            try {
                this.content = yield this._markdownUrlLoaderService.load((_a = this.url) !== null && _a !== void 0 ? _a : '', this.httpOptions);
            }
            catch (error) {
                this.loadFailed.emit(error);
            }
            finally {
                this.loading = false;
                this._changeDetectorRef.markForCheck();
            }
        });
    }
}
TdFlavoredMarkdownLoaderComponent.ɵfac = function TdFlavoredMarkdownLoaderComponent_Factory(t) { return new (t || TdFlavoredMarkdownLoaderComponent)(i0.ɵɵdirectiveInject(i0.ChangeDetectorRef), i0.ɵɵdirectiveInject(i1$1.TdMarkdownLoaderService)); };
TdFlavoredMarkdownLoaderComponent.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: TdFlavoredMarkdownLoaderComponent, selectors: [["td-flavored-markdown-loader"]], inputs: { url: "url", httpOptions: "httpOptions", anchor: "anchor", copyCodeToClipboard: "copyCodeToClipboard", copyCodeTooltips: "copyCodeTooltips", useCfmList: "useCfmList" }, outputs: { contentReady: "contentReady", loadFailed: "loadFailed", buttonClicked: "buttonClicked" }, features: [i0.ɵɵNgOnChangesFeature], decls: 2, vars: 2, consts: [["mode", "indeterminate", "color", "accent", "class", "sticky", 3, "ngClass", 4, "ngIf"], [3, "content", "hostedUrl", "anchor", "copyCodeToClipboard", "copyCodeTooltips", "useCfmList", "contentReady", "buttonClicked", 4, "ngIf"], ["mode", "indeterminate", "color", "accent", 1, "sticky", 3, "ngClass"], [3, "content", "hostedUrl", "anchor", "copyCodeToClipboard", "copyCodeTooltips", "useCfmList", "contentReady", "buttonClicked"]], template: function TdFlavoredMarkdownLoaderComponent_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵtemplate(0, TdFlavoredMarkdownLoaderComponent_mat_progress_bar_0_Template, 1, 1, "mat-progress-bar", 0);
            i0.ɵɵtemplate(1, TdFlavoredMarkdownLoaderComponent_td_flavored_markdown_1_Template, 1, 6, "td-flavored-markdown", 1);
        }
        if (rf & 2) {
            i0.ɵɵproperty("ngIf", ctx.loading);
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("ngIf", !ctx.loading);
        }
    }, dependencies: [i1.NgClass, i1.NgIf, i3$2.MatProgressBar, TdFlavoredMarkdownComponent], styles: ["[_nghost-%COMP%]{display:block}.sticky[_ngcontent-%COMP%]{position:absolute;top:0}.delay[_ngcontent-%COMP%]{animation:_ngcontent-%COMP%_delay-animation;animation-duration:.6s}@keyframes _ngcontent-%COMP%_delay-animation{0%{opacity:0}99%{opacity:0}to{opacity:1}}"], changeDetection: 0 });
(function () {
    (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(TdFlavoredMarkdownLoaderComponent, [{
            type: Component,
            args: [{ selector: 'td-flavored-markdown-loader', changeDetection: ChangeDetectionStrategy.OnPush, template: "<mat-progress-bar\n  [ngClass]=\"'delay'\"\n  *ngIf=\"loading\"\n  mode=\"indeterminate\"\n  color=\"accent\"\n  class=\"sticky\"\n></mat-progress-bar>\n<td-flavored-markdown\n  *ngIf=\"!loading\"\n  [content]=\"content\"\n  [hostedUrl]=\"url ?? ''\"\n  [anchor]=\"anchor ?? ''\"\n  [copyCodeToClipboard]=\"copyCodeToClipboard\"\n  [copyCodeTooltips]=\"copyCodeTooltips\"\n  [useCfmList]=\"useCfmList\"\n  (contentReady)=\"contentReady.emit()\"\n  (buttonClicked)=\"buttonClicked.emit($event)\"\n></td-flavored-markdown>\n", styles: [":host{display:block}.sticky{position:absolute;top:0}.delay{animation:delay-animation;animation-duration:.6s}@keyframes delay-animation{0%{opacity:0}99%{opacity:0}to{opacity:1}}\n"] }]
        }], function () { return [{ type: i0.ChangeDetectorRef }, { type: i1$1.TdMarkdownLoaderService }]; }, { url: [{
                type: Input
            }], httpOptions: [{
                type: Input
            }], anchor: [{
                type: Input
            }], copyCodeToClipboard: [{
                type: Input
            }], copyCodeTooltips: [{
                type: Input
            }], useCfmList: [{
                type: Input
            }], contentReady: [{
                type: Output
            }], loadFailed: [{
                type: Output
            }], buttonClicked: [{
                type: Output
            }] });
})();

class CovalentFlavoredMarkdownModule {
}
CovalentFlavoredMarkdownModule.ɵfac = function CovalentFlavoredMarkdownModule_Factory(t) { return new (t || CovalentFlavoredMarkdownModule)(); };
CovalentFlavoredMarkdownModule.ɵmod = /*@__PURE__*/ i0.ɵɵdefineNgModule({ type: CovalentFlavoredMarkdownModule });
CovalentFlavoredMarkdownModule.ɵinj = /*@__PURE__*/ i0.ɵɵdefineInjector({ imports: [CommonModule,
        MatCheckboxModule,
        MatListModule,
        MatProgressBarModule,
        CovalentHighlightModule,
        CovalentMarkdownModule,
        MatButtonModule,
        MatTableModule,
        MatSortModule] });
(function () {
    (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(CovalentFlavoredMarkdownModule, [{
            type: NgModule,
            args: [{
                    imports: [
                        CommonModule,
                        MatCheckboxModule,
                        MatListModule,
                        MatProgressBarModule,
                        CovalentHighlightModule,
                        CovalentMarkdownModule,
                        MatButtonModule,
                        MatTableModule,
                        MatSortModule,
                    ],
                    declarations: [
                        TdFlavoredListComponent,
                        TdFlavoredMarkdownComponent,
                        TdFlavoredMarkdownContainerDirective,
                        TdFlavoredMarkdownLoaderComponent,
                        TdFlavoredMarkdownButtonComponent,
                        TdFlavoredMarkdownTableComponent,
                    ],
                    exports: [TdFlavoredMarkdownComponent, TdFlavoredMarkdownLoaderComponent],
                }]
        }], null, null);
})();
(function () {
    (typeof ngJitMode === "undefined" || ngJitMode) && i0.ɵɵsetNgModuleScope(CovalentFlavoredMarkdownModule, { declarations: [TdFlavoredListComponent,
            TdFlavoredMarkdownComponent,
            TdFlavoredMarkdownContainerDirective,
            TdFlavoredMarkdownLoaderComponent,
            TdFlavoredMarkdownButtonComponent,
            TdFlavoredMarkdownTableComponent], imports: [CommonModule,
            MatCheckboxModule,
            MatListModule,
            MatProgressBarModule,
            CovalentHighlightModule,
            CovalentMarkdownModule,
            MatButtonModule,
            MatTableModule,
            MatSortModule], exports: [TdFlavoredMarkdownComponent, TdFlavoredMarkdownLoaderComponent] });
})();

/**
 * Generated bundle index. Do not edit.
 */

export { CovalentFlavoredMarkdownModule, TdFlavoredMarkdownButtonComponent, TdFlavoredMarkdownComponent, TdFlavoredMarkdownContainerDirective, TdFlavoredMarkdownLoaderComponent, TdFlavoredMarkdownTableComponent };
//# sourceMappingURL=covalent-flavored-markdown.mjs.map
